// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - PERK SELECT
// This is a wrapper for the lobby's perk select menu
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

namespace PerkSelectMenu
{
	using LBPerks;
	private int PlayerInput, PlayerInputOld;
	
	// ------------------------/
	// Open the perk select menu
	// SERVER
	// ------------------------/
	
	script "OpenPerkSelectMenu" NET
	{
		if (CheckInventory("PerkMenuOpen"))
		{
			InvEnsure("PerkMenuOpen", 0);
			FreezeMe(false);
		}
		else if (PerkSwitchAllowed())
		{
			InvEnsure("PerkMenuOpen", 1);
			FreezeMe(true);
			ACS_NamedExecuteAlways("PerkSelectHandler", 0);
		}
		else
			LocalAmbientSound("perkselect/denied", 127);
	}
	
	// ------------------------/
	// Actual handler for the perk select menu
	// CLIENT
	// ------------------------/
	
	script "PerkSelectHandler" CLIENTSIDE
	{
		if (WrongClient())
			terminate;
			
		GameState.HUD.PerkSelectIsOpen = true;
			
		LBP_Init(true);
			
		while (CheckInventory("PerkMenuOpen"))
		{
			UpdateCursor(true);
			
			PlayerInput = GetPlayerInput(-1, INPUT_BUTTONS);
			PlayerInputOld = GetPlayerInput(-1, INPUT_OLDBUTTONS);
			
			// Pressed left click for the first time
			if (ButtonPressed(BT_ATTACK, PlayerInput, PlayerInputOld))
				PS_MouseClick();

			LBP_Tick();
			LBP_Draw();
			delay(1);
		}
		
		LBP_Cleanup();
		
		LocalAmbientSound("perkselect/close", 127);
		
		DrawCursor("");
		
		GameState.HUD.PerkSelectIsOpen = false;
	}
	
	// ------------------------/
	// Click!
	// ------------------------/
	
	private void PS_MouseClick()
	{
		LBP_MouseClick();
	}
}