// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - PERK LIST [CORE]
// Core code related to the perk list
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

struct PerkListEntry
{
	str ID;						// Shorthand ID to use for the perk
	str DisplayName;			// Name to show this perk as
	int Hash;					// Hash based on the perk's ID
	bool Hidden;				// Unselectable
	
	str IconHUD;				// Icon to show on HUD
	str IconSelect;				// Icon to show in perk select
	
	str GrenadeClass;			// Class of the grenade WEAPON to use
};

struct PerkListEntry PerkList[MAX_PERKS];
int PerkListSize;

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Register a perk to the core list
// ------------------------/

void RegisterPerk(str ID, str Display)
{
	PerkList[PerkListSize].ID = ID;
	PerkList[PerkListSize].DisplayName = Display;
	
	// Generate a hash
	PerkList[PerkListSize].Hash = FakeHash(ID);
	
	PerkList[PerkListSize].IconHUD = "PHUDGREN";
	
	// fix later
	PerkList[PerkListSize].GrenadeClass = "Type97Grenade";
	
	PerkListSize ++;
}

// ------------------------/
// Register a perk's icon
// ------------------------/

void RegisterPerkIcon(str iHUD, str iSel)
{
	PerkList[PerkListSize-1].IconHUD = iHUD;
	PerkList[PerkListSize-1].IconSelect = iSel;
}

// ------------------------/
// Disable a perk
// ------------------------/

void SetPerkDisabled(bool dis = true)
{
	PerkList[PerkListSize-1].Hidden = dis;
}

// ------------------------/
// Find a perk by its hash
// ------------------------/

int PerkByHash(int hash)
{
	for (int i=0; i<PerkListSize; i++)
	{
		if (PerkList[i].Hash == hash)
			return i;
	}
	
	return -1;
}