// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Z O M B I E   T O R R E N T   2
// TRADER FUNCTIONS
//
// These are SERVERSIDED functions that get called
// They return response codes
//
// Bottom half is clientsided RESPONSE codes
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// ------------------------/
// Buy a weapon!
// ------------------------/

int TF_BuyWeapon(int index)
{
	// Do we have enough money?
	int GoalPrice = GetBuyPrice(index);
	
	// We already have it
	if (CheckInventory(WeaponList[index].Class))
		return TRES_HAS;
	
	// Not enough money!
	if (CheckInventory("Money") < GoalPrice)
		return TRES_BROKE;
		
	// Take the money
	TakeInventory("Money", GoalPrice);
	
	// Give the item
	GiveInventory(WeaponList[index].Class, 1);
	
	return TRES_SUCCESS;
}

// ------------------------/
// Sell a weapon!
// ------------------------/

int TF_SellWeapon(int index)
{
	int SellPrice = GetSellPrice(index);
	
	// We DO NOT have it
	if (!CheckInventory(WeaponList[index].Class))
		return TRES_NOTHAVE;

	// Take the item
	TakeInventory(WeaponList[index].Class, 1);
	
	// Give the money
	GiveInventory("Money", SellPrice);
	
	return TRES_SUCCESS;
}

// ------------------------/
// Exit the menu
// ------------------------/

int TF_ExitMenu()
{
	if (!CheckInventory("TraderMenuOpen"))
		return TRES_FAILED;
		
	ACS_ExecuteAlways(SCRIPT_TRADERMENU, 0);
	return TRES_SUCCESS;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Bought a weapon
// Returns TRUE if successful
//
// If true, update the sell menu (We obtained an item!)
// ------------------------/

bool TF_BuyWeaponResponse(int res, int arg, str successor)
{
	switch (res)
	{
		// Good!
		
		case TRES_SUCCESS:
			SetFont(FNT_PLAIN);
			Print(s:successor);
			return true;
			break;
			
		// Not enough cash
		// (Cash is checked clientside, this will only happen if someone hacks)
		
		case TRES_BROKE:
			SetFont(FNT_PLAIN);
			Print(s:"You don't have enough money for that.");
			break;
			
		// Already have
		// (Wep is checked clientside, this will only happen if someone hacks)
		
		case TRES_HAS:
			SetFont(FNT_PLAIN);
			Print(s:"You already have this weapon.");
			break;
			
		// ???
		
		default:
			ZTPrint("TF_BuyWeaponResponse - ???");
			break;
	}
	
	return false;
}

// ------------------------/
// Sold a weapon
// Returns TRUE if successful
//
// If true, update the sell menu (We lost an item!)
// ------------------------/

bool TF_SellWeaponResponse(int res, int arg, str successor)
{
	switch (res)
	{
		// Good to go
		
		case TRES_SUCCESS:
			SetFont(FNT_PLAIN);
			Print(s:successor);
			return true;
			break;
			
		// We don't have this?
		// Shouldn't have passed clientside check, HACKS
		
		case TRES_NOTHAVE:
			SetFont(FNT_PLAIN);
			Print(s:"You do not have this???");
			break;
			
		default:
			ZTPrint("TF_SellWeaponResponse - ???");
			break;
	}
	
	return false;
}